
function UpdateScript() {
  var person = GetInputPerson();
  
  if (UpdateCamera()) {
    var tile_x = ScreenToMapX(GetPersonLayer(person), 0) / GetTileWidth();
    var tile_y = ScreenToMapY(GetPersonLayer(person), 0) / GetTileHeight();
    var tile = GetTile(tile_x, tile_y, GetPersonLayer(person));
    var surface = GetTileSurface(tile);
    var color = surface.getPixel(0, 0);
    SetPersonMask(person, color);
  }

  if (GetPersonData(person)["current_weapon"] == "spear") {
    SetPersonX("spear", GetPersonX(person) - 10);
    SetPersonY("spear", GetPersonY(person) - 5);
    SetPersonLayer("spear", 1);
  }
}

function RenderScript() {

}

function OnEnterMap() {
  CenterCamera();
}

function CenterCamera() {
  SetCameraX(Math.floor(GetCameraX() / GetScreenWidth() ) + GetScreenWidth()  / 2 - 1);
  SetCameraY(Math.floor(GetCameraY() / GetScreenHeight()) + GetScreenHeight() / 2 - 1);  
}

function UpdateCamera() {
  var changed = false;
  var player = GetInputPerson();
  
  var old_camera_x = GetCameraX();
  var old_camera_y = GetCameraY();

  if (MapToScreenX(GetPersonLayer(player), GetPersonX(player)) > GetScreenWidth()) {
    SetCameraX(GetCameraX() + GetScreenWidth());
  }
  else
  if (MapToScreenX(GetPersonLayer(player), GetPersonX(player)) < 0) {
    SetCameraX(GetCameraX() - GetScreenWidth());
  }

  if (MapToScreenY(GetPersonLayer(player), GetPersonY(player)) > GetScreenHeight()) {
    SetCameraY(GetCameraY() + GetScreenHeight());
  }
  else
  if (MapToScreenY(GetPersonLayer(player), GetPersonY(player)) < 0) {
    SetCameraY(GetCameraY() - GetScreenHeight());
  }

  return (GetCameraX() != old_camera_x || GetCameraY() != old_camera_y);
}

function WarpToA2a() {
  SetPersonX(GetInputPerson(), GetPersonX("A2a") - GetTileWidth());
  SetPersonY(GetInputPerson(), GetPersonY("A2a"));
}

function WarpToA2b() {
  SetPersonX(GetInputPerson(), GetPersonX("A2b") - GetTileWidth());
  SetPersonY(GetInputPerson(), GetPersonY("A2b"));
}


function WarpToA1a() {
  SetPersonX(GetInputPerson(), GetPersonX("A1a") + GetTileWidth());
  SetPersonY(GetInputPerson(), GetPersonY("A1a"));
}

function WarpToA1b() {
  SetPersonX(GetInputPerson(), GetPersonX("A1b") + GetTileWidth());
  SetPersonY(GetInputPerson(), GetPersonY("A1b"));
}




function WarpToC2a() {
  SetPersonX(GetInputPerson(), GetPersonX("C2a") - GetTileWidth());
  SetPersonY(GetInputPerson(), GetPersonY("C2a"));
}

function WarpToC2b() {
  SetPersonX(GetInputPerson(), GetPersonX("C2b") - GetTileWidth());
  SetPersonY(GetInputPerson(), GetPersonY("C2b"));
}


function WarpToC1a() {
  SetPersonX(GetInputPerson(), GetPersonX("C1a") + GetTileWidth());
  SetPersonY(GetInputPerson(), GetPersonY("C1a"));
}

function WarpToC1b() {
  SetPersonX(GetInputPerson(), GetPersonX("C1b") + GetTileWidth());
  SetPersonY(GetInputPerson(), GetPersonY("C1b"));
}

function SetPersonValue(person, key, value)
{ 
  var person_data = GetPersonData(person);
  person_data[key] = value;
  SetPersonData(person, person_data);
}

function OnTouchYellowKey()
{
  SetPersonValue(GetInputPerson(), "yellow_key", 1);
  DestroyPerson(GetCurrentPerson());
}

function OnTouchWhiteKey()
{
  SetPersonValue(GetInputPerson(), "white_key", 1);
  DestroyPerson(GetCurrentPerson());
}

function OnTouchYellowDoor()
{
  if (GetPersonData(GetInputPerson())["yellow_key"] == 1) {
    SetPersonDirection(GetCurrentPerson(), "off");
    SetPersonLayer(GetCurrentPerson(), 1);
  }
}

function OnTouchWhiteDoor()
{
  if (GetPersonData(GetInputPerson())["white_key"] == 1) {
    DestroyPerson(GetCurrentPerson());
  }
}

function OnTouchSpear()
{
  SetPersonValue(GetInputPerson(), "current_weapon", "spear");
}

function OnMoveMonster(name)
{
  var person = GetInputPerson();
  if (GetPersonData(person)["current_weapon"] == "spear") {

  }
}

function game() {
  CreatePerson("hero", "sprite.rss", false);
  AttachInput("hero");

  SetRenderScript("RenderScript()");
  SetUpdateScript("UpdateScript()");
  SetDefaultMapScript(SCRIPT_ON_ENTER_MAP, "OnEnterMap()");
  
  SetPersonSpeed("hero", 2);
  
  MapEngine("main.rmp", 60);
}
